require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_filterrule',
  dscmeta_resource_friendly_name: 'FilterRule',
  dscmeta_resource_name: 'MimSyncFilterRule',
  dscmeta_resource_implementation: 'MOF',
  dscmeta_module_name: 'MimDsc',
  dscmeta_module_version: '0.0.1',
  docs: 'The DSC FilterRule resource type.
         Automatically generated from version 0.0.1',
  features: ['simple_get_filter', 'canonicalize', 'custom_insync'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    validation_mode: {
      type:      'Enum[property, resource]',
      desc:      'Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode (resource).',
      behaviour: :parameter,
      default:   'property',
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_type: {
      type: 'Optional[String]',
      desc: ' ',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_ensure: {
      type: "Optional[Enum['Present', 'Absent']]",
      desc: ' ',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_managementagentname: {
      type: 'String',
      desc: ' ',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_cdobjecttype: {
      type: 'String',
      desc: ' ',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_filteralternative: {
      type: "Optional[Array[Struct[{
              filtercondition => Array[Struct[{
                operator => Optional[String],
                cdattribute => Optional[String],
                value => Optional[String],
                cim_instance_type => Enum['MimSyncFilterCondition']
              }]],
              id => Optional[String],
            }]]]",
      desc: ' ',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'MimSyncFilterAlternative[]',
      mof_is_embedded: true,
    },
    dsc_importfilter: {
      type: 'Optional[Boolean]',
      desc: ' ',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
  },
)
