require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_joinrule',
  dscmeta_resource_friendly_name: 'JoinRule',
  dscmeta_resource_name: 'MimSyncJoinRule',
  dscmeta_resource_implementation: 'MOF',
  dscmeta_module_name: 'MimDsc',
  dscmeta_module_version: '0.0.1',
  docs: 'The DSC JoinRule resource type.
         Automatically generated from version 0.0.1',
  features: ['simple_get_filter', 'canonicalize', 'custom_insync'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    validation_mode: {
      type:      'Enum[property, resource]',
      desc:      'Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode (resource).',
      behaviour: :parameter,
      default:   'property',
    },
    dsc_joincriterion: {
      type: "Optional[Array[Struct[{
              id => Optional[String],
              resolutionscriptcontext => Optional[String],
              joincriteriatype => Optional[String],
              order => Optional[Integer[0, 65535]],
              mvobjecttype => Optional[String],
              attributemapping => Array[Struct[{
                scriptcontext => Optional[String],
                cdattribute => Optional[Array[String]],
                mvattribute => Optional[String],
                cim_instance_type => Enum['MimSyncAttributeMapping'],
                mappingtype => Optional[String]
              }]],
              resolutiontype => Optional[String]
            }]]]",
      desc: 'Array of Join Conditions',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'MimSyncJoinCriterion[]',
      mof_is_embedded: true,
    },
    dsc_managementagentname: {
      type: 'String',
      desc: ' ',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_cdobjecttype: {
      type: 'String',
      desc: ' ',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_ensure: {
      type: "Optional[Enum['Present', 'Absent']]",
      desc: ' ',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
  },
)
